Index: /NEMO/branches/2020/dev_r13787_doc_latex_recovery/doc/latex/NEMO/main/bibliography.bib
===================================================================
--- /NEMO/branches/2020/dev_r13787_doc_latex_recovery/doc/latex/NEMO/main/bibliography.bib	(revision 14068)
+++ /NEMO/branches/2020/dev_r13787_doc_latex_recovery/doc/latex/NEMO/main/bibliography.bib	(revision 14069)
@@ -519,4 +519,19 @@
 }
 
+@article{         carrere.lyard_GRL03,
+  title         = "Modeling the barotropic response of the global ocean to
+                  atmospheric wind and pressure forcing - comparisons with
+                  observations",
+  journal       = "Geophysical Research Letters",
+  volume        = "30",
+  number        = "6",
+  author        = "L. Carr\`{e}re and F. Lyard",
+  year          = "2003",
+  month         = "mar",
+  publisher     = "American Geophysical Union (AGU)",
+  issn          = "0094-8276",
+  doi           = "10.1029/2002gl016473"
+}
+
 @techreport{      chanut_rpt05,
   title         = "Nesting code for {NEMO}",
@@ -758,18 +773,46 @@
 }
 
-@Article{Edson_2013,
-  author       = {Edson, James B. and Jampana, Venkata and Weller, Robert A. and Bigorre, Sebastien
-                  P. and Plueddemann, Albert J. and Fairall, Christopher W. and Miller, Scott D. and
-                  Mahrt, Larry and Vickers, Dean and Hersbach, Hans},
-  title       = {On the Exchange of Momentum over the Open Ocean},
-  year       = 2013,
-  volume       = 43,
-  number       = 8,
-  month       = {Aug},
-  pages       = {1589–1610},
-  issn       = {1520-0485},
-  doi       = {10.1175/jpo-d-12-0173.1},
-  journal      = {Journal of Physical Oceanography},
-  publisher    = {American Meteorological Society}
+@article{ edson.jampana.ea_JPO13,
+title = "On the Exchange of Momentum over the Open Ocean",
+pages = "1589--1610",
+journal = "Journal of Physical Oceanography",
+volume = "43",
+number = "8",
+author = "Edson, James B. and Jampana, Venkata and Weller, Robert A. and Bigorre, Sebastien P. and Plueddemann, Albert J. and Fairall, Christopher W. and Miller, Scott D. and Mahrt, Larry and Vickers, Dean and Hersbach, Hans",
+year = "2013",
+month = "aug",
+publisher = "American Meteorological Society",
+issn = "0022-3670",
+doi = "10.1175/JPO-D-12-0173.1"
+}
+
+@article{         egbert.ray_JGR01,
+  title         = "Estimates of {M2} tidal energy dissipation from
+                  {TOPEX}/Poseidon altimeter data",
+  pages         = "22475--22502",
+  journal       = "Journal of Geophysical Research",
+  volume        = "106",
+  number        = "C10",
+  author        = "G. D. Egbert and R. D. Ray",
+  year          = "2001",
+  month         = "oct",
+  publisher     = "American Geophysical Union (AGU)",
+  issn          = "0148-0227",
+  doi           = "10.1029/2000jc000699"
+}
+
+@article{         egbert.ray_N00,
+  title         = "Significant dissipation of tidal energy in the deep ocean
+                  inferred from satellite altimeter data",
+  pages         = "775--778",
+  journal       = "Nature",
+  volume        = "405",
+  number        = "6788",
+  author        = "G. D. Egbert and R. D. Ray",
+  year          = "2000",
+  month         = "jun",
+  publisher     = "Springer Nature",
+  issn          = "1476-4687",
+  doi           = "10.1038/35015531"
 }
 
@@ -987,4 +1030,34 @@
 }
 
+@article{         gerdes_JGR93*a,
+  title         = "A primitive equation ocean circulation model using a
+                  general vertical coordinate transformation: 1. Description
+                  and testing of the model",
+  pages         = "14683--14701",
+  journal       = "Journal of Geophysical Research",
+  volume        = "98",
+  number        = "C8",
+  author        = "R. Gerdes",
+  year          = "1993",
+  publisher     = "American Geophysical Union (AGU)",
+  issn          = "0148-0227",
+  doi           = "10.1029/93jc00760"
+}
+
+@article{         gerdes_JGR93*b,
+  title         = "A primitive equation ocean circulation model using a
+                  general vertical coordinate transformation: 2. Application
+                  to an overflow problem",
+  pages         = "14703--14726",
+  journal       = "Journal of Geophysical Research",
+  volume        = "98",
+  number        = "C8",
+  author        = "R. Gerdes",
+  year          = "1993",
+  publisher     = "American Geophysical Union (AGU)",
+  issn          = "0148-0227",
+  doi           = "10.1029/93jc00788"
+}
+
 @techreport{      gibson_rpt86,
   title         = "Standards for software development and maintenance",
@@ -1026,4 +1099,20 @@
   issn          = "0148-0227",
   doi           = "10.1029/2010jb007867"
+}
+
+@article{         goosse.deleersnijder.ea_JGR99,
+  title         = "Sensitivity of a global coupled ocean-sea ice model to the
+                  parameterization of vertical mixing",
+  pages         = "13681--13695",
+  journal       = "Journal of Geophysical Research",
+  volume        = "104",
+  number        = "C6",
+  author        = "H. Goosse and E. Deleersnijder and T. Fichefet and M. H.
+                  England",
+  year          = "1999",
+  month         = "jun",
+  publisher     = "American Geophysical Union (AGU)",
+  issn          = "0148-0227",
+  doi           = "10.1029/1999jc900099"
 }
 
@@ -1452,4 +1541,20 @@
 }
 
+@article{         koch-larrouy.lengaigne.ea_CD10,
+  title         = "Tidal mixing in the Indonesian Seas and its effect on the
+                  tropical climate system",
+  pages         = "891--904",
+  journal       = "Climate Dynamics",
+  volume        = "34",
+  number        = "6",
+  author        = "A. Koch-Larrouy and M. Lengaigne and P. Terray and G.
+                  Madec and S. Masson",
+  year          = "2010",
+  month         = "aug",
+  publisher     = "Springer Nature",
+  issn          = "1432-0894",
+  doi           = "10.1007/s00382-009-0642-4"
+}
+
 @article{         koch-larrouy.madec.ea_GRL07,
   title         = "On the transformation of Pacific water into Indonesian
@@ -1468,4 +1573,35 @@
 }
 
+@article{         koch-larrouy.madec.ea_OD08*a,
+  title         = "Water mass transformation along the Indonesian ThroughFlow
+                  in an {OGCM}",
+  pages         = "289--309",
+  journal       = "Ocean Dynamics",
+  volume        = "58",
+  number        = "3-4",
+  author        = "A. Koch-Larrouy and G. Madec and B. Blanke and R. Molcard",
+  year          = "2008",
+  month         = "oct",
+  publisher     = "Springer Nature",
+  issn          = "1616-7228",
+  doi           = "10.1007/s10236-008-0155-4"
+}
+
+@article{         koch-larrouy.madec.ea_OD08*b,
+  title         = "Physical processes contributing to the water mass
+                  transformation of the Indonesian ThroughFlow",
+  pages         = "275--288",
+  journal       = "Ocean Dynamics",
+  volume        = "58",
+  number        = "3-4",
+  author        = "A. Koch-Larrouy and G. Madec and D. Iudicone and A.
+                  Atmadipoera and R. Molcard",
+  year          = "2008",
+  month         = "oct",
+  publisher     = "Springer Nature",
+  issn          = "1616-7228",
+  doi           = "10.1007/s10236-008-0154-5"
+}
+
 @article{         kolmogorov_IANS42,
   title         = "Equations of turbulent motion in an incompressible fluid",
@@ -1478,31 +1614,22 @@
 }
 
-@Article{Kraus_1967,
-  author       = {Kraus, E. B. and Turner, J. S.},
-  title       = {A one-dimensional model of the seasonal thermocline II. The general theory and its
-                  consequences},
-  year       = 1967,
-  volume       = 19,
-  number       = 1,
-  month       = {Jan},
-  pages       = {98–106},
-  issn       = {2153-3490},
-  doi       = {10.3402/tellusa.v19i1.9753},
-  journal      = {Tellus},
-  publisher    = {Informa UK Limited}
-}
-
-@Article{Large_1994,
-  author       = {Large, W. G. and McWilliams, J. C. and Doney, S. C.},
-  title       = {Oceanic vertical mixing: A review and a model with a nonlocal boundary layer
-                  parameterization},
-  year       = 1994,
-  volume       = 32,
-  number       = 4,
-  pages       = 363,
-  issn       = {8755-1209},
-  doi       = {10.1029/94rg01872},
-  journal      = {Reviews of Geophysics},
-  publisher    = {American Geophysical Union (AGU)}
+@article{         kraus.turner_tellus67,
+  author = {Kraus, E.B. and Turner, J.},
+  journal = {Tellus},
+  pages = {98--106},
+  title = {A one dimensional model of the seasonal thermocline {II}. {T}he general theory and its consequences},
+  volume = {19},
+  year = {1967}
+}
+
+@article{        large.ea_RG97,
+  author        = "Large, W. G. and McWilliams, J. C. and Doney, S. C.",
+  doi           = "10.1029/94RG01872",
+  journal       = "Reviews of Geophysics",
+  number        = {4},
+  pages         = {363--403},
+  publisher     = {AGU},
+  title         = "Oceanic vertical mixing: {A} review and a model with a nonlocal boundary layer parameterization",
+  year          = "1994"
 }
 
@@ -1777,14 +1904,4 @@
   issn          = "1543-9542",
   doi           = "10.1357/0022240933223945"
-}
-
-@Article{        love_PRSLA1909,
-  author       = "A. E. H. Love",
-  title        = "The Yielding of the Earth to Disturbing Forces",
-  journal      = "Proc. R. Soc. Lond. A",
-  year         = "1909",
-  volume       = "82",
-  pages        = "73-88",
-  doi          = "10.1098/rspa.1909.0008"
 }
 
@@ -2087,17 +2204,13 @@
 }
 
-@Article{McWILLIAMS_1997,
-  author       = {McWILLIAMS, JAMES C. and SULLIVAN, PETER P. and MOENG, CHIN-HOH},
-  title       = {Langmuir turbulence in the ocean},
-  year       = 1997,
-  volume       = 334,
-  month       = {Mar},
-  pages       = {1–30},
-  issn       = {1469-7645},
-  doi       = {10.1017/s0022112096004375},
-  journal      = {Journal of Fluid Mechanics},
-  publisher    = {Cambridge University Press (CUP)}
-}
-
+@article{mcwilliams.ea_JFM97,
+	author = {McWilliams, James C. and Sullivan, Peter P. and Moeng, Chin-Hoh},
+	doi = {10.1017/S0022112096004375},
+	journal = {Journal of Fluid Mechanics},
+	pages = {1--30},
+	title = {Langmuir turbulence in the ocean},
+	volume = {334},
+	year = {1997},
+}
 @article{         mellor.blumberg_JPO04,
   title         = "Wave Breaking and Ocean Surface Layer Thermal Response",
@@ -2553,16 +2666,32 @@
 }
 
-@Article{SMAGORINSKY_1963,
-  author       = {SMAGORINSKY, J.},
-  title       = {GENERAL CIRCULATION EXPERIMENTS WITH THE PRIMITIVE EQUATIONS},
-  year       = 1963,
-  volume       = 91,
-  number       = 3,
-  month       = {Mar},
-  pages       = {99–164},
-  issn       = {1520-0493},
-  doi       = {10.1175/1520-0493(1963)091<0099:gcewtp>2.3.co;2},
-  journal      = {Monthly Weather Review},
-  publisher    = {American Meteorological Society}
+@article{         simmons.jayne.ea_OM04,
+  title         = "Tidally driven mixing in a numerical model of the ocean
+                  general circulation",
+  pages         = "245--263",
+  journal       = "Ocean Modelling",
+  volume        = "6",
+  number        = "3-4",
+  author        = "H. L. Simmons and S. R. Jayne and L. C. {St Laurent} and
+                  A. J. Weaver",
+  year          = "2004",
+  month         = "jan",
+  publisher     = "Elsevier BV",
+  issn          = "1463-5003",
+  doi           = "10.1016/s1463-5003(03)00011-8"
+}
+
+@article{         smagorinsky_MW63,
+  title         = "General circulation experiments with the primitive equations: I. The basic experiment ",
+  pages         = "99--164",
+  journal       = "Monthly Weather Review",
+  volume        = "91",
+  number        = "3",
+  author        = "J. Smagorinsky",
+  year          = "1963",
+  month         = "mar",
+  publisher     = "American Meteorological Society",
+  issn          = "1520-0493",
+  doi           = "10.1175/1520-0493(1963)091<0099:GCEWTP>2.3.CO;2"
 }
 
@@ -2595,4 +2724,19 @@
   issn          = "1520-0493",
   doi           = "10.1175/1520-0493(1998)126<3213:agpgff>2.0.co;2"
+}
+
+@article{         st-laurent.nash_DSR04,
+  title         = "An examination of the radiative and dissipative properties
+                  of deep ocean internal tides",
+  pages         = "3029--3042",
+  journal       = "Deep Sea Research",
+  volume        = "51",
+  number        = "25-26",
+  author        = "L. C. {St Laurent} and J. D. Nash",
+  year          = "2004",
+  month         = "dec",
+  publisher     = "Elsevier BV",
+  issn          = "0967-0645",
+  doi           = "10.1016/j.dsr2.2004.09.008"
 }
 
@@ -2798,4 +2942,36 @@
 }
 
+@article{         vancoppenolle.fichefet.ea_OM09*a,
+  title         = "Simulating the mass balance and salinity of Arctic and
+                  Antarctic sea ice. 1. Model description and validation",
+  pages         = "33--53",
+  journal       = "Ocean Modelling",
+  volume        = "27",
+  number        = "1-2",
+  author        = "M. Vancoppenolle and T. Fichefet and H. Goosse and S.
+                  Bouillon and G. Madec and M. A. Morales Maqueda",
+  year          = "2009",
+  month         = "jan",
+  publisher     = "Elsevier BV",
+  issn          = "1463-5003",
+  doi           = "10.1016/j.ocemod.2008.10.005"
+}
+
+@article{         vancoppenolle.fichefet.ea_OM09*b,
+  title         = "Simulating the mass balance and salinity of Arctic and
+                  Antarctic sea ice. 2. Importance of sea ice salinity
+                  variations",
+  pages         = "54--69",
+  journal       = "Ocean Modelling",
+  volume        = "27",
+  number        = "1-2",
+  author        = "M. Vancoppenolle and T. Fichefet and H. Goosse",
+  year          = "2009",
+  month         = "jan",
+  publisher     = "Elsevier BV",
+  issn          = "1463-5003",
+  doi           = "10.1016/j.ocemod.2008.11.003"
+}
+
 @article{         warner.defne.ea_CG13,
   title         = "A wetting and drying scheme for {ROMS}",
@@ -2981,6 +3157,4 @@
 }
 
-
-
 @article{kraus.businger_QJRMS96,
 author = "E. B. Kraus and J. A. Businger",