Index: /NEMO/branches/2020/dev_r13787_doc_latex_recovery/src/ICE/ice.F90
===================================================================
--- /NEMO/branches/2020/dev_r13787_doc_latex_recovery/src/ICE/ice.F90	(revision 14108)
+++ /NEMO/branches/2020/dev_r13787_doc_latex_recovery/src/ICE/ice.F90	(revision 14109)
@@ -256,6 +256,6 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   divu_i          !: Divergence of the velocity field             [s-1]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   shear_i         !: Shear of the velocity field                  [s-1]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   aniso_11, aniso_12   !: structure tensor elements
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   rdg_conv
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   aniso_11, aniso_12   !: structure tensor elements
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   rdg_conv
    !
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   t_bo            !: Sea-Ice bottom temperature [Kelvin]
Index: /NEMO/branches/2020/dev_r13787_doc_latex_recovery/src/ICE/icedyn_adv_pra.F90
===================================================================
--- /NEMO/branches/2020/dev_r13787_doc_latex_recovery/src/ICE/icedyn_adv_pra.F90	(revision 14108)
+++ /NEMO/branches/2020/dev_r13787_doc_latex_recovery/src/ICE/icedyn_adv_pra.F90	(revision 14109)
@@ -1079,46 +1079,46 @@
          !
          !                                                           ! ice thickness
-         CALL iom_rstput( iter, nitrst, numriw, 'sxice' , sxice)
-         CALL iom_rstput( iter, nitrst, numriw, 'syice' , syice)
-         CALL iom_rstput( iter, nitrst, numriw, 'sxxice', sxxice)
-         CALL iom_rstput( iter, nitrst, numriw, 'syyice', syyice)
-         CALL iom_rstput( iter, nitrst, numriw, 'sxyice', sxyice)
+         CALL iom_rstput( iter, nitrst, numriw, 'sxice' , sxice  )
+         CALL iom_rstput( iter, nitrst, numriw, 'syice' , syice  )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxxice', sxxice )
+         CALL iom_rstput( iter, nitrst, numriw, 'syyice', syyice )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxyice', sxyice )
          !                                                           ! snow thickness
-         CALL iom_rstput( iter, nitrst, numriw, 'sxsn'  , sxsn )
-         CALL iom_rstput( iter, nitrst, numriw, 'sysn'  , sysn )
-         CALL iom_rstput( iter, nitrst, numriw, 'sxxsn' , sxxsn )
-         CALL iom_rstput( iter, nitrst, numriw, 'syysn' , syysn )
-         CALL iom_rstput( iter, nitrst, numriw, 'sxysn' , sxysn )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxsn'  , sxsn   )
+         CALL iom_rstput( iter, nitrst, numriw, 'sysn'  , sysn   )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxxsn' , sxxsn  )
+         CALL iom_rstput( iter, nitrst, numriw, 'syysn' , syysn  )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxysn' , sxysn  )
          !                                                           ! ice concentration
-         CALL iom_rstput( iter, nitrst, numriw, 'sxa'   , sxa  )
-         CALL iom_rstput( iter, nitrst, numriw, 'sya'   , sya  )
-         CALL iom_rstput( iter, nitrst, numriw, 'sxxa'  , sxxa  )
-         CALL iom_rstput( iter, nitrst, numriw, 'syya'  , syya  )
-         CALL iom_rstput( iter, nitrst, numriw, 'sxya'  , sxya  )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxa'   , sxa    )
+         CALL iom_rstput( iter, nitrst, numriw, 'sya'   , sya    )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxxa'  , sxxa   )
+         CALL iom_rstput( iter, nitrst, numriw, 'syya'  , syya   )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxya'  , sxya   )
          !                                                           ! ice salinity
-         CALL iom_rstput( iter, nitrst, numriw, 'sxsal' , sxsal)
-         CALL iom_rstput( iter, nitrst, numriw, 'sysal' , sysal)
-         CALL iom_rstput( iter, nitrst, numriw, 'sxxsal', sxxsal)
-         CALL iom_rstput( iter, nitrst, numriw, 'syysal', syysal)
-         CALL iom_rstput( iter, nitrst, numriw, 'sxysal', sxysal)
+         CALL iom_rstput( iter, nitrst, numriw, 'sxsal' , sxsal  )
+         CALL iom_rstput( iter, nitrst, numriw, 'sysal' , sysal  )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxxsal', sxxsal )
+         CALL iom_rstput( iter, nitrst, numriw, 'syysal', syysal )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxysal', sxysal )
          !                                                           ! ice age
-         CALL iom_rstput( iter, nitrst, numriw, 'sxage' , sxage)
-         CALL iom_rstput( iter, nitrst, numriw, 'syage' , syage)
-         CALL iom_rstput( iter, nitrst, numriw, 'sxxage', sxxage)
-         CALL iom_rstput( iter, nitrst, numriw, 'syyage', syyage)
-         CALL iom_rstput( iter, nitrst, numriw, 'sxyage', sxyage)
+         CALL iom_rstput( iter, nitrst, numriw, 'sxage' , sxage  )
+         CALL iom_rstput( iter, nitrst, numriw, 'syage' , syage  )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxxage', sxxage )
+         CALL iom_rstput( iter, nitrst, numriw, 'syyage', syyage )
+         CALL iom_rstput( iter, nitrst, numriw, 'sxyage', sxyage )
          !                                                           ! snow layers heat content
          DO jk = 1, nlay_s
             WRITE(zchar1,'(I2.2)') jk
             znam = 'sxc0'//'_l'//zchar1  ;   z3d(:,:,:) = sxc0 (:,:,jk,:)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z3d)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z3d )
             znam = 'syc0'//'_l'//zchar1  ;   z3d(:,:,:) = syc0 (:,:,jk,:)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z3d)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z3d )
             znam = 'sxxc0'//'_l'//zchar1 ;   z3d(:,:,:) = sxxc0(:,:,jk,:)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z3d)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z3d )
             znam = 'syyc0'//'_l'//zchar1 ;   z3d(:,:,:) = syyc0(:,:,jk,:)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z3d)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z3d )
             znam = 'sxyc0'//'_l'//zchar1 ;   z3d(:,:,:) = sxyc0(:,:,jk,:)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z3d)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z3d )
          END DO
          !                                                           ! ice layers heat content
@@ -1126,13 +1126,13 @@
             WRITE(zchar1,'(I2.2)') jk
             znam = 'sxe'//'_l'//zchar1   ;   z3d(:,:,:) = sxe (:,:,jk,:)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z3d)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z3d )
             znam = 'sye'//'_l'//zchar1   ;   z3d(:,:,:) = sye (:,:,jk,:)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z3d)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z3d )
             znam = 'sxxe'//'_l'//zchar1  ;   z3d(:,:,:) = sxxe(:,:,jk,:)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z3d)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z3d )
             znam = 'syye'//'_l'//zchar1  ;   z3d(:,:,:) = syye(:,:,jk,:)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z3d)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z3d )
             znam = 'sxye'//'_l'//zchar1  ;   z3d(:,:,:) = sxye(:,:,jk,:)
-            CALL iom_rstput( iter, nitrst, numriw, znam , z3d)
+            CALL iom_rstput( iter, nitrst, numriw, znam , z3d )
          END DO
          !
Index: /NEMO/branches/2020/dev_r13787_doc_latex_recovery/src/OCE/SBC/sbccpl.F90
===================================================================
--- /NEMO/branches/2020/dev_r13787_doc_latex_recovery/src/OCE/SBC/sbccpl.F90	(revision 14108)
+++ /NEMO/branches/2020/dev_r13787_doc_latex_recovery/src/OCE/SBC/sbccpl.F90	(revision 14109)
@@ -1765,5 +1765,5 @@
       CASE( 'none'      )       ! Not available as for now: needs additional coding below when computing zevap_oce
       !                         ! since fields received are not defined with none option
-         CALL ctl_stop( 'STOP', 'sbccpl/sbc_cpl_ice_flx: some fields are not defined. Change sn_rcv_emp value in namelist namsbc_cpl' )
+         CALL ctl_stop('STOP', 'sbccpl/sbc_cpl_ice_flx: some fields are not defined. Change sn_rcv_emp value in namelist namsbc_cpl')
       END SELECT
 
@@ -2037,16 +2037,20 @@
 #endif
       ! outputs
-      IF( srcv(jpr_cal)%laction       ) CALL iom_put('hflx_cal_cea'    , - frcv(jpr_cal)%z3(:,:,1) * rLfus )                      ! latent heat from calving
-      IF( srcv(jpr_icb)%laction       ) CALL iom_put('hflx_icb_cea'    , - frcv(jpr_icb)%z3(:,:,1) * rLfus )                      ! latent heat from icebergs melting
-      IF( iom_use('hflx_rain_cea')    ) CALL iom_put('hflx_rain_cea'   , ( tprecip(:,:) - sprecip(:,:) ) * zcptrain(:,:) )        ! heat flux from rain (cell average)
-      IF( iom_use('hflx_evap_cea')    ) CALL iom_put('hflx_evap_cea'   , ( frcv(jpr_tevp)%z3(:,:,1) - frcv(jpr_ievp)%z3(:,:,1) &
-           &                                                              * picefr(:,:) ) * zcptn(:,:) * tmask(:,:,1) )            ! heat flux from evap (cell average)
-      IF( iom_use('hflx_prec_cea')    ) CALL iom_put('hflx_prec_cea'   ,  sprecip(:,:) * ( zcptsnw(:,:) - rLfus ) +  &                    ! heat flux from all precip (cell avg)
-         &                                                               ( tprecip(:,:) - sprecip(:,:) ) * zcptrain(:,:) )
-      IF( iom_use('hflx_snow_cea')    ) CALL iom_put('hflx_snow_cea'   , sprecip(:,:) * ( zcptsnw(:,:) - rLfus )  )               ! heat flux from snow (cell average)
-      IF( iom_use('hflx_snow_ao_cea') ) CALL iom_put('hflx_snow_ao_cea', sprecip(:,:) * ( zcptsnw(:,:) - rLfus ) &
-           &                                                              * ( 1._wp - zsnw(:,:) )                  )               ! heat flux from snow (over ocean)
-      IF( iom_use('hflx_snow_ai_cea') ) CALL iom_put('hflx_snow_ai_cea', sprecip(:,:) * ( zcptsnw(:,:) - rLfus ) &
-           &                                                              *           zsnw(:,:)                    )               ! heat flux from snow (over ice)
+      IF ( srcv(jpr_cal)%laction ) CALL iom_put('hflx_cal_cea' , - frcv(jpr_cal)%z3(:,:,1) * rLfus ) ! latent heat from calving
+      IF ( srcv(jpr_icb)%laction ) CALL iom_put('hflx_icb_cea' , - frcv(jpr_icb)%z3(:,:,1) * rLfus ) ! latent heat from icebergs melting
+      IF (        iom_use('hflx_rain_cea') )    &                                                    ! heat flux from rain (cell average)
+         &   CALL iom_put('hflx_rain_cea' , ( tprecip(:,:) - sprecip(:,:) ) * zcptrain(:,:) )
+      IF (        iom_use('hflx_evap_cea') )    &                                                    ! heat flux from evap (cell average)
+         &   CALL iom_put('hflx_evap_cea' , ( frcv(jpr_tevp)%z3(:,:,1) - zevap_ice_total(:,:) * picefr(:,:) )  &
+         &                                  * zcptn(:,:) * tmask(:,:,1) )
+      IF (        iom_use('hflx_prec_cea') )    &                                                    ! heat flux from all precip (cell avg)
+         &   CALL iom_put('hflx_prec_cea' ,    sprecip(:,:) * ( zcptsnw(:,:) - rLfus )  &
+         &                                 + ( tprecip(:,:) - sprecip(:,:) ) * zcptrain(:,:) )
+      IF (        iom_use('hflx_snow_cea') )    &                                                    ! heat flux from snow (cell average)
+         &   CALL iom_put('hflx_snow_cea'   , sprecip(:,:) * ( zcptsnw(:,:) - rLfus )  )
+      IF (        iom_use('hflx_snow_ao_cea') ) &                                                    ! heat flux from snow (over ocean)
+         &   CALL iom_put('hflx_snow_ao_cea', sprecip(:,:) * ( zcptsnw(:,:) - rLfus ) * ( 1._wp - zsnw(:,:) ) )
+      IF (        iom_use('hflx_snow_ai_cea') ) &                                                    ! heat flux from snow (over ice)
+         &   CALL iom_put('hflx_snow_ai_cea', sprecip(:,:) * ( zcptsnw(:,:) - rLfus ) *  zsnw(:,:) )
       ! note: hflx for runoff and iceshelf are done in sbcrnf and sbcisf resp.
       !
@@ -2102,5 +2106,5 @@
       CASE( 'none'      )       ! Not available as for now: needs additional coding
       !                         ! since fields received, here zqsr_tot,  are not defined with none option
-         CALL ctl_stop( 'STOP', 'sbccpl/sbc_cpl_ice_flx: some fields are not defined. Change sn_rcv_qsr value in namelist namsbc_cpl' )
+         CALL ctl_stop('STOP', 'sbccpl/sbc_cpl_ice_flx: some fields are not defined. Change sn_rcv_qsr value in namelist namsbc_cpl')
       END SELECT
       IF( ln_dm2dc .AND. ln_cpl ) THEN   ! modify qsr to include the diurnal cycle