Index: NEMO/trunk/tests/test_cases.bib
===================================================================
--- NEMO/trunk/tests/test_cases.bib	(revision 14090)
+++ NEMO/trunk/tests/test_cases.bib	(revision 14113)
@@ -1,127 +1,115 @@
-@book{HAIDVOGEL1999,
-   author = {D. B. Haidvogel and A. Beckmann},
-   publisher = {Imperial College Press, London},
-   year = {1999},
-   title = {Numerical ocean circulation modeling}
+
+@article{         brodeau.barnier.ea_JPO16,
+  title         = "Climatologically Significant Effects of Some
+                  Approximations in the Bulk Parameterizations of Turbulent
+                  Air–Sea Fluxes",
+  pages         = "5--28",
+  journal       = "Journal of Physical Oceanography",
+  volume        = "47",
+  number        = "1",
+  author        = "Brodeau, Laurent and Barnier, Bernard and Gulev, Sergey K.
+                  and Woods, Cian",
+  year          = "2016",
+  month         = "Dec",
+  publisher     = "American Meteorological Society",
+  issn          = "1520-0485",
+  doi           = "10.1175/jpo-d-16-0169.1"
 }
 
-@book{BURCHARD2002,
-   title={GETM: A General Estuarine Transport Model; Scientific Documentation},
-   author={Burchard, Hans and Bolding, Karsten},
-   year={2002},
-   publisher={European Commission, Joint Research Centre, Institute for Environment and Sustainability}
+@techreport{      burchard.bolding_trpt02,
+  title         = "GETM, A General Estuarine Transport Model: Scientific
+                  Documentation",
+  pages         = "",
+  series        = "Tech. Rep. EUR 20253 EN",
+  author        = "Burchard, Hans and Bolding, Karsten",
+  institution   = "European Commission",
+  year          = "2002",
+  month         = "01"
 }
 
-@article{ILICAK2012,
-   title = "Spurious dianeutral mixing and the role of momentum closure",
-   journal = "Ocean Modelling",
-   volume = "45-46",
-   pages = "37 - 58",
-   year = "2012",
-   issn = "1463-5003",
-   doi = "10.1016/j.ocemod.2011.10.003",
-   author = "Mehmet Ilicak and Alistair J. Adcroft and Stephen M. Griffies and Robert W. Hallberg",
-   keywords = "Spurious dianeutral transport, Cabbeling, Overflows, Exchange-flow, Ocean models, Momentum transport, Tracer advection, Reference potential energy"
+@article{         haidvogel.beckmann_SESM99,
+  title         = "Numerical Ocean Circulation Modeling",
+  journal       = "Series on Environmental Science and Management",
+  author        = "Haidvogel, Dale B and Beckmann, Aike",
+  year          = "1999",
+  month         = "Apr",
+  publisher     = "IMPERIAL COLLEGE PRESS",
+  issn          = "0219-9793",
+  isbn          = "9781860943935",
+  doi           = "10.1142/p097"
 }
 
-@article{DEBREU2012,
-   title = "Two-way nesting in split-explicit ocean models: Algorithms, implementation and validation",
-   journal = "Ocean Modelling",
-   volume = "49-50",
-   pages = "1 - 21",
-   year = "2012",
-   issn = "1463-5003",
-   doi = "10.1016/j.ocemod.2012.03.003",
-   author = "Laurent Debreu and Patrick Marchesiello and Pierrick Penven and Gildas Cambon",
-   keywords = "Two-way nesting, Finite difference method, Modeling, Boundary conditions, Coastal upwelling"
+@article{         ilıcak.adcroft.ea_OM12,
+  title         = "Spurious dianeutral mixing and the role of momentum
+                  closure",
+  pages         = "37--58",
+  journal       = "Ocean Modelling",
+  volume        = "45-46",
+  author        = "Ilıcak, Mehmet and Adcroft, Alistair J. and Griffies,
+                  Stephen M. and Hallberg, Robert W.",
+  year          = "2012",
+  month         = "Jan",
+  publisher     = "Elsevier BV",
+  issn          = "1463-5003",
+  doi           = "10.1016/j.ocemod.2011.10.003"
 }
 
-@article{PENVEN2006,
-   title = "Evaluation and application of the ROMS 1-way embedding procedure to the central california upwelling system",
-   journal = "Ocean Modelling",
-   volume = "12",
-   number = "1",
-   pages = "157 - 187",
-   year = "2006",
-   issn = "1463-5003",
-   doi = "10.1016/j.ocemod.2005.05.002",
-   author = "Pierrick Penven and Laurent Debreu and Patrick Marchesiello and James C. McWilliams",
-   keywords = "Ocean models, Boundary conditions, Embedding, Coastal upwelling, Mesoscale eddies, Eddy kinetic energy, North America, West Coast, Central upwelling system, Monterey Bay, 35–41°N, 128–121°W"
+@article{         lipscomb.hunke_MWR04,
+  title         = "Modeling Sea Ice Transport Using Incremental Remapping",
+  pages         = "1341--1354",
+  journal       = "Monthly Weather Review",
+  volume        = "132",
+  number        = "6",
+  author        = "Lipscomb, William H. and Hunke, Elizabeth C.",
+  year          = "2004",
+  month         = "Jun",
+  publisher     = "American Meteorological Society",
+  issn          = "1520-0493",
+  doi           = "10.1175/1520-0493(2004)132<1341:msitui>2.0.co;2"
 }
 
-@article{SPALL1991,
-   author = {Spall, M. A. and Holland, W. R.},
-   title = {A Nested Primitive Equation Model for Oceanic Applications},
-   journal = {Journal of Physical Oceanography},
-   volume = {21},
-   number = {2},
-   pages = {205-220},
-   year = {1991},
-   doi = {10.1175/1520-0485(1991)021<0205:ANPEMF>2.0.CO;2},
+@article{         losch_JGR08,
+  title         = "Modeling ice shelf cavities in a z coordinate ocean
+                  general circulation model",
+  journal       = "Journal of Geophysical Research",
+  volume        = "113",
+  number        = "C8",
+  author        = "Losch, M.",
+  year          = "2008",
+  month         = "Aug",
+  publisher     = "American Geophysical Union (AGU)",
+  issn          = "0148-0227",
+  doi           = "10.1029/2007jc004368"
 }
 
-@article{MATHIOT2017,
-   author = {Mathiot, P. and Jenkins, A. and Harris, C. and Madec, G.},
-   title = {Explicit representation and parametrised impacts of under ice shelf seas in the ${z}^{\ast}$ coordinate ocean model NEMO 3.6},
-   journal = {Geoscientific Model Development},
-   volume = {10},
-   year = {2017},
-   number = {7},
-   pages = {2849--2874},
-   url = {https://www.geosci-model-dev.net/10/2849/2017/},
-   doi = {10.5194/gmd-10-2849-2017}
+@article{         mathiot.jenkins.ea_GMD17,
+  title         = "Explicit representation and parametrised impacts of under
+                  ice shelf seas in the ${z}^{\ast}$ coordinate ocean model
+                  NEMO 3.6",
+  pages         = "2849--2874",
+  journal       = "Geoscientific Model Development",
+  volume        = "10",
+  number        = "7",
+  author        = "Mathiot, Pierre and Jenkins, Adrian and Harris,
+                  Christopher and Madec, Gurvan",
+  year          = "2017",
+  month         = "Jul",
+  publisher     = "Copernicus GmbH",
+  issn          = "1991-9603",
+  doi           = "10.5194/gmd-10-2849-2017"
 }
 
-@article{LOSCH2008,
-   author = {Losch, M.},
-   title = {Modeling ice shelf cavities in a z coordinate ocean general circulation model},
-   journal = {Journal of Geophysical Research: Oceans},
-   volume = {113},
-   year = {2008},
-   number = {C8},
-   pages = {},
-   keywords = {Ice shelf cavities, numerical ocean modeling, z coordinates},
-   doi = {10.1029/2007JC004368},
-   url = {https://agupubs.onlinelibrary.wiley.com/doi/abs/10.1029/2007JC004368},
-   eprint = {https://agupubs.onlinelibrary.wiley.com/doi/pdf/10.1029/2007JC004368},
-   abstract = {Processes at the ice shelf-ocean interface and in particular in ice shelf cavities around Antarctica have an observable effect on the solutions of basin scale to global coupled ice-ocean models. Despite this, these processes are not routinely represented in global ocean and climate models. It is shown that a new ice shelf cavity model for z coordinate models can reproduce results from an intercomparison project of earlier approaches with vertical ?~C or isopycnic coordinates. As a proof of concept, ice shelves are incorporated in a 100-year global integration of a z coordinate model. In this simulation, glacial meltwater can be traced as far as north as 15??S. The observed effects of processes in the ice shelf cavities agree with previous results from a ?~C coordinate model, notably the increase in sea ice thickness. However, melt rates are overestimated probably because the parameterization of basal melting does not suit the low resolution of this configuration.}
+@article{         schär.smolarkiewicz_JCP96,
+  title         = "A Synchronous and Iterative Flux-Correction Formalism for
+                  Coupled Transport Equations",
+  pages         = "101--120",
+  journal       = "Journal of Computational Physics",
+  volume        = "128",
+  number        = "1",
+  author        = "Schär, Christoph and Smolarkiewicz, Piotr K.",
+  year          = "1996",
+  month         = "Oct",
+  publisher     = "Elsevier BV",
+  issn          = "0021-9991",
+  doi           = "10.1006/jcph.1996.0198"
 }
-
-@article{LIPSCOMB2004,
-   author = {Lipscomb, William H. and Hunke, Elizabeth C.},
-   title = {Modeling Sea Ice Transport Using Incremental Remapping},
-   journal = {Monthly Weather Review},
-   volume = {132},
-   number = {6},
-   pages = {1341-1354},
-   year = {2004},
-   doi = {10.1175/1520-0493(2004)132<1341:MSITUI>2.0.CO;2},
-   URL = {https://doi.org/10.1175/1520-0493(2004)132<1341:MSITUI>2.0.CO;2},
-   eprint = {https://doi.org/10.1175/1520-0493(2004)132<1341:MSITUI>2.0.CO;2},
-   abstract = { Abstract Sea ice models contain transport equations for the area, volume, and energy of ice and snow in various thickness categories. These equations typically are solved with first-order-accurate upwind schemes, which are very diffusive; with second-order-accurate centered schemes, which are highly oscillatory; or with more sophisticated second-order schemes that are computationally costly if many quantities must be transported [e.g., multidimensional positive-definite advection transport algorithm (MPDATA)]. Here an incremental remapping scheme, originally designed for horizontal transport in ocean models, is adapted for sea ice transport. This scheme has several desirable features: it preserves the monotonicity of both conserved quantities and tracers; it is second-order accurate except where the accuracy is reduced locally to preserve monotonicity; and it efficiently solves the large number of equations in sea ice models with multiple thickness categories and tracers. Remapping outperforms the first-order upwind scheme and basic MPDATA scheme in several simple test problems. In realistic model runs, remapping is less diffusive than the upwind scheme and about twice as fast as MPDATA. }
-}
-
-@article{SCHAR1996,
-   author = {Christoph Schär and Piotr K. Smolarkiewicz},
-   title = {A Synchronous and Iterative Flux-Correction Formalism for Coupled Transport Equations},
-   journal = {Journal of Computational Physics},
-   volume = {128},
-   number = {1},
-   pages = {101 - 120},
-   year = {1996},
-   issn = {0021-9991},
-   doi = {https://doi.org/10.1006/jcph.1996.0198},
-   url = {http://www.sciencedirect.com/science/article/pii/S0021999196901989},
-   abstract = {Many problems of fluid dynamics involve the coupled transport of several, density-like, dependent variables (for instance, densities of mass and momenta in elastic flows). In this paper, a conservative and synchronous flux-corrected transport (FCT) formalism is developed which aims at a consistent transport of such variables. The technique differs from traditional FCT algorithms in two respects. First, the limiting of transportive fluxes of the primary variables (e.g., mass and momentum) does not derive from smooth estimates of the variables, but it derives from analytic constraints implied by the Lagrangian form of the governing continuity equations, which are imposed on the specific mixing ratios of the variables (e.g., velocity components). Second, the traditional FCT limiting based on sufficiency conditions is augmented by an iterative procedure which approaches the necessity requirements. This procedure can also be used in the framework of traditional FCT schemes, and a demonstration is provided that it can significantly reduce some of the pathological behaviors of FCT algorithms. Although the approach derived is applicable to the transport of arbitrary conserved quantities, it is particularly useful for the synchronous transport of mass and momenta in elastic flows, where it assures intrinsic stability of the algorithm regardless of the magnitude of the mass-density variable. This latter property becomes especially important in fluids with large density variations, or in models with a material “vertical” coordinate (e.g., geophysical hydrostatic stratified flows in isopycnic/isentropic coordinates), where material surfaces can collapse to zero-mass layers admitting, therefore, arbitrarily large local Courant numbers.}
-}
-
-@article{Brodeau_al_2017,
-author={Laurent Brodeau and Bernard Barnier and Sergey Gulev and Cian Woods},
-title={Climatologically significant effects of some approximations in the bulk parameterizations of turbulent air-sea fluxes},
-journal={J. Phys. Oceanogr.},
-doi={10.1175/JPO-D-16-0169.1},
-year={2017},
-pages = {5-28},
-volume={47},
-number={1}
-}